#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Pixmap.H>
#include <FL/fl_draw.H>

#define GLASS_LEFT_X 0
#define GLASS_TOP_Y 0
#define GLASS_WIDTH 15
#define GLASS_HEIGHT 20
#define SQUARE_DIM 32
#define BORDER_DIM 8
#define GLASS_WIDTH_PIX (GLASS_WIDTH * SQUARE_DIM + 2 * BORDER_DIM)
#define GLASS_HEIGHT_PIX (GLASS_HEIGHT * SQUARE_DIM + 2 * BORDER_DIM)
#define BUTTON_DIM 32
#define MAIN_WND_WIDTH (GLASS_LEFT_X + GLASS_WIDTH_PIX + 2)
#define MAIN_WND_HEIGHT (GLASS_TOP_Y + GLASS_HEIGHT_PIX + 2 + BUTTON_DIM + 4)

#include "square.xpm"
Fl_Pixmap square_img (square_xpm);

class glass_widget : public Fl_Widget
{
  void draw ()
  {
    unsigned i, j;
    unsigned dy;

    for (j = 0; j < GLASS_HEIGHT; j++)
    {
      dy = (GLASS_HEIGHT - j - 1) * SQUARE_DIM + BORDER_DIM;
      for (i = 0; i < GLASS_WIDTH; i++)
	if (!((i % 3) && (j % 3)))
#if 1
	  fl_draw_pixmap (square_xpm, x () + SQUARE_DIM * i + BORDER_DIM, y () + dy);
#else
	  square_img.draw (x () + SQUARE_DIM * i + BORDER_DIM, y () + dy);
#endif
    };
  }
public:
  glass_widget(int x, int y, int w, int h)
  : Fl_Widget(x, y, w, h)
  {}
};

class tetris_window : public Fl_Double_Window
{
  glass_widget glass;
public:
  tetris_window ()
  : Fl_Double_Window (MAIN_WND_WIDTH, MAIN_WND_HEIGHT, "FLTetris"),
    glass(0, 0, MAIN_WND_WIDTH, MAIN_WND_HEIGHT)
  {
    end ();
  }
 };

int main (int argc, char * * argv)
 {
  tetris_window window;
  window.show (argc, argv);
  return Fl::run ();
 }
